﻿
# SimpleMacros
SimpleMacros was created to give you a better way of interacting with mods that can only be controlled through console commands.

## Features
* Define your favorite commands in the config file and trigger them using:
	* In-game menu that displays buttons for all commands defined in the config file
	* Keyboard shortcuts
* Run your commands multiple times, for example a macro for `spawn_ai` (from RoR2Cheats) can be run 50 times to spawn 50 enemies.

### Screenshots
![In-Game Menu](https://i.imgur.com/fPZxzGp.png)

![Aftermath](https://i.imgur.com/rvbXsV1.png)

## Usage
* Install **SimpleMacros** by placing .dll files in the `BepInEx\plugins` folder or use your favorite mod manager
* Run the game, this will create the configuration file
* Open the following file in a text editor: `BepInEx\config\local.recursiveGecko.ror2.SimpleMacros.cfg`
* Add your commands, following the syntax described below
* Click `Reload config` or restart the game

Sample macros in the configuration file depend on the [RoR2Cheats](https://thunderstore.io/package/Morris1927/RoR2Cheats/) mod.

### Configuration file syntax

The configuration file can contain any number of macros, each one defined like this:
```
[Name of your macro]
command=console command that you want to run
shortcut=F3
repeat=20 
```

Name of your macro: Can be almost anything you want, as long as there are no duplicates.

`shortcut`: **Optional**. Hot key for this macro. You can find a full list here: [https://docs.unity3d.com/ScriptReference/KeyCode.html](https://docs.unity3d.com/ScriptReference/KeyCode.html) 

`repeat`: **Optional**. How many times to execute this command when the macro is triggered.

Since both of these properties are optional, you don't have to define them. A macro without `shortcut` and `repeat` options will still be available as a button in the in-game menu.

There is also an option that allows you to set a shortcut to toggle the visibility of the in-game menu:
`toggle_menu_shortcut=F11`

## Planned features
* In-game macro customization

## Bug reports & Feature requests
Please create an issue [here](https://github.com/recursiveGecko/RoR2_Mods/issues). 
If you're reporting a bug, make sure to describe what happened, include your configuration file and any error output relating to SimpleMacros.



## Version history

* **v1.1.0** - Bump version, edit mod README
* **v1.0.2** - Only show in-game menu when mouse cursor is available (Game is paused or Tab is being held)
* **v1.0.1** - Remove stray config file from .zip and update mod description
* **v1.0.0** - Initial release

## Credits

Icon made by [Becris](https://www.flaticon.com/authors/becris)